// Copyright (c) 2023 Dominic Masters
// 
// This software is released under the MIT License.
// https://opensource.org/licenses/MIT

#include "UIGroupContainer.hpp"

using namespace Dawn;

std::vector<std::shared_ptr<UIElement>> UIGroupContainer::getChildren() {
  return this->children;
}

void UIGroupContainer::appendChild(std::shared_ptr<UIElement> child) {
  assertNotNull(child, "Cannot append a null child!");
  this->children.push_back(child);
}

void UIGroupContainer::removeChild(std::shared_ptr<UIElement> child) {
  assertNotNull(child, "Cannot remove a null child!");
  auto it = std::find(this->children.begin(), this->children.end(), child);
  if(it == this->children.end()) return;
  this->children.erase(it);
}

void UIGroupContainer::clearChildren() {
  this->children.clear();
}